<template>
  <section class="dashboard-content text-center">
    <main role="main" class="container">
      <div class="starter-template pb-3">
        <button
          type="button"
          data-dismiss="modal"
          aria-label="Close"
          class="close"
          v-on:click="cancel()"
        >
          <i class="icon-close f-18" />
        </button>
      </div>
      <div class="starter-template pb-2 form-wrapper m-auto">
        <h2 class="f-30 d-flex align-items-center justify-content-center">Send Payment</h2>
      </div>
      <div class="form-centered">
        <div class="clearfix mb-3 w-450">
          <form class="text-left" v-on:submit.prevent="sendMoney()">
            <div class="mb-3">
              <div v-if="!invalidSendRecipientStatus">
                <label for="receiversAddress">To:<span class="label-display" v-if="receiverAddressDisplay">{{receiverAddressDisplay}}</span></label>
              </div>
              <div v-if="invalidSendRecipientStatus">
                <label for="receiversAddress">
                  <span class="text-warning">{{ invalidSendRecipientStatus }}</span>
                </label>
              </div>
              <WalletAddressInput
                :disabled="defaultSendDisable"
                @address-change="onRecipientAddressChanged"
                id="receiversAddress"
                :value="receiverAddress"
                placeholder="Recipient's Address" 
                required
              />
            </div>
            <div class="mb-3">
              <div v-if="!invalidSendAmountStatus">
                <label for="transferAmount">
                  Amount to Send:
                  <span class="text-secondary label-display">
                    (Wallet Bal:
                    {{viewBalance | minor-unit-currency}})
                  </span>
                </label>
              </div>
              <div v-if="invalidSendAmountStatus">
                <label for="transferAmount">
                  <span class="text-warning">{{ invalidSendAmountStatus }}</span>
                  <span class="text-secondary label-display">
                    (Wal Bal:
                    {{viewBalance | minor-unit-currency}})
                  </span>
                  <span
                    class="text-float-right key"
                    v-on:click="initiateTransferPopup()"
                    v-show="showTransferModal"
                  >Transfer Funds</span>
                </label>
              </div>
              <div class="f-18 text-gray8080">
                <CurrencyInput
                  :disabled="defaultSendDisable"
                  @amount-change="onSendValueChanged"
                  id="transferAmount"
                  required
                />
              </div>
              <div class="py-1 f-14 text-warning">
                <span>{{otherStatus}}</span>&nbsp;
              </div>
              <div class="align-middle text-center mb-3">
                <div class="form-elements-justify">
                  <button
                    type="button"
                    data-dismiss="modal"
                    class="btn btn-link-warning"
                    v-on:click="cancel()"
                  >Cancel</button>
                  <button
                    type="submit"
                    class="btn btn-success btn-send btn-send-screen-lg f-18"
                    :disabled="!correctReceiverAddress || !correctTransferAmount || defaultSendDisable"
                  >Send Payment</button>
                </div>
              </div>
            </div>
          </form>
        </div>
      </div>
    </main>
  </section>
</template>

<script lang="ts">
import { Inject } from "inversify-props";
import { Component, Watch } from "vue-property-decorator";
import { mixins } from "vue-class-component";
import Money, { Currency } from "tpfs-money";

import __env from "@/env";
import appSettings from "@/constants/appSettings";
import displayMessages from "@/constants/displayMessages";
import { IMemberApiService } from "@/services/IMemberApiService";
import CurrencyInput from "@/components/bricks/CurrencyInput.vue";
import WalletAddressInput from "@/components/bricks/WalletAddressInput.vue";
import StoreModules from "@/mixins/StoreModules";
import TransferModal from "@/components/buildings/TransferModal.vue";

@Component({
  components: {
    CurrencyInput,
    WalletAddressInput
  }
})
export default class Send extends mixins(StoreModules) {
  @Inject("IMemberApiService")
  public api!: IMemberApiService;

  public invalidSendRecipientStatus: string | null = null;
  public otherStatus: string | null = null;
  public invalidSendAmountStatus: string | null = null;
  public correctReceiverAddress: boolean | null = null;
  public correctTransferAmount: boolean | null = null;
  public defaultSendDisable: boolean | null = null;
  public userSetAddress: string | null = null;
  public currency: Currency = "USD";
  public transferAmount: Money = new Money(0, this.currency);
  public locale: string = "en";

  public created() {
    if (!!this.receiverAddress) {
      this.receiverAddressValidation(this.receiverAddress);
    }
  }

  public destroyed() {
    this.xandModule.setRecipient(null);
  }

  public cancel(): void {
    this.$router.replace("/");
  }

  public onSendValueChanged(m: Money) {
    this.transferAmount = m;
  }

  public onRecipientAddressChanged(s: string) {
    this.receiverAddress = s;
  }

  public async sendMoney(): Promise<void> {
    try {
      this.defaultSendDisable = true;
      const request = {
        fromAddress: this.userModule.userDetails.address || "",
        toAddress: this.receiverAddress,
        amountInMinorUnit: this.transferAmount.amountInMinorUnits.toNumber()
      };
      const { transactionId } = await this.api.transfer(request);
      this.$router.replace({
        name: `receipt`,
        params: {
          txid: transactionId,
          receiverKey: request.toAddress,
          amount: this.transferAmount.minorUnitsString
        }
      });
    } catch (err) {
      this.$remoteLogger.error(err);
      this.otherStatus = displayMessages.FAILED_SEND_STATUS;
    } finally {
      this.defaultSendDisable = null;
    }
  }

  public initiateTransferPopup() {
    this.modalModule.openOrReplaceModal({ modal: TransferModal, attr: {} });
  }

  public receiverAddressValidation(receiverAddress: string | null): boolean {
    if (
      receiverAddress !== null &&
      receiverAddress !== undefined &&
      receiverAddress !== ""
    ) {
      if (this.userModule.userDetails.address !== receiverAddress) {
        if (receiverAddress.length !== appSettings.VALID_ADDRESS_LENGTH) {
          this.invalidSendRecipientStatus =
            displayMessages.INVALID_LENGTH_RECEIVER_ADDRESS;
          this.correctReceiverAddress = false;
        } else {
          this.otherStatus = displayMessages.EMPTY_MSG;
          this.invalidSendRecipientStatus = displayMessages.EMPTY_MSG;
          this.correctReceiverAddress = true;
        }
      } else {
        this.invalidSendRecipientStatus =
          displayMessages.INVALID_OWN_ACCOUNT_TRANSFER;
        this.correctReceiverAddress = false;
      }
    } else {
      this.invalidSendRecipientStatus =
        displayMessages.RECEIVER_ADDRESS_MANDATORY;
      this.correctReceiverAddress = false;
    }
    return this.correctReceiverAddress;
  }

  public transferAmountValidation(transferAmount: Money) {
    if (transferAmount.isZero) {
      this.invalidSendAmountStatus = displayMessages.INVALID_AMOUNT;
      this.correctTransferAmount = false;
      return;
    }

    if (transferAmount.amountInMinorUnits.isGreaterThan(this.currentBalance)) {
      this.invalidSendAmountStatus = displayMessages.INSUFFICIENT_BALANCE;
      this.correctTransferAmount = false;
      return;
    }

    this.otherStatus = displayMessages.EMPTY_MSG;
    this.invalidSendAmountStatus = displayMessages.EMPTY_MSG;
    this.correctTransferAmount = true;
  }

  get viewBalance(): number {
    // TODO: change minor unit balance in userDetails to Money (#169046381)
    return this.userModule.userDetails.userBalanceInMinorUnit;
  }

  get receiverAddress(): string {
    return this.xandModule.recipient || "";
  }
  set receiverAddress(newVal: string) {
    this.xandModule.setRecipient(newVal);
  }

  get receiverAddressDisplay(): string {
    const contacts = this.contactsModule.contacts;
    const foundContact: { contactName?: string; company: string } | undefined =
      contacts[this.receiverAddress];
    if (foundContact) {
      return `${
        foundContact.contactName ? foundContact.contactName + ", " : ""
      }${foundContact.company}`;
    }
    return "";
  }

  get currentBalance(): number {
    return this.userModule.userDetails.userBalanceInMinorUnit;
  }

  get showTransferModal() {
    // TODO: Once vuex store uses Money for balances implement Money comparison functions and use (#169046381)
    return (
      this.transferAmount.amountInMinorUnits.isGreaterThan(this.viewBalance) ||
      !this.viewBalance
    );
  }

  @Watch("transferAmount")
  public onTransferAmount(): void {
    this.transferAmountValidation(this.transferAmount);
  }

  @Watch("currentBalance")
  public onCurrentBalance(): void {
    this.transferAmountValidation(this.transferAmount);
  }

  @Watch("receiverAddress")
  public onReceiverAddress(): void {
    this.receiverAddressValidation(this.receiverAddress);
  }
}
</script>

<style lang="scss" scoped>
.label-display {
  margin-left: .5rem;
}
</style>